com.jogamp.gluegen.cgram.types

## Class PointerType

- java.lang.Object
- - com.jogamp.gluegen.cgram.types.Type
  - - com.jogamp.gluegen.cgram.types.PointerType

- All Implemented Interfaces:
    Cloneable

      public class PointerType
      extends Type
      implements Cloneable

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PointerType(SizeThunk size, Type targetType, int cvAttributes)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PointerType` | `asPointer()` Casts this to a PointerType or returns null if not a PointerType.
    `boolean` | `equals(Object arg)` Equality test for Types.
    `Type` | `getBaseElementType()` Helper method to returns the bottom-most element type of this type.
    `String` | `getName(boolean includeCVAttrs)` Returns the name of this type, optionally including const/volatile attributes.
    `Type` | `getTargetType()`
    `int` | `hashCode()` Hashcode for Types.
    `boolean` | `hasTypedefedName()`
    `boolean` | `isFunctionPointer()` Convenience routine indicating whether this Type is a pointer to a function.
    `void` | `setName(String name)` Set the name of this type; used for handling typedefs.
    `String` | `toString()` Returns a string representation of this type.
    `String` | `toString(String functionName, String callingConvention)` For use only when printing function pointers.
    `void` | `visit(TypeVisitor arg)` Visit this type and all of the component types of this one; for example, the return type and argument types of a FunctionType.

    - ### Methods inherited from class com.jogamp.gluegen.cgram.types.Type

      `arrayDimension, asArray, asBit, asCompound, asDouble, asEnum, asFloat, asFunction, asInt, asVoid, clone, getCVAttributes, getCVAttributesString, getCVVariant, getDebugString, getName, getSize, getSize, hasTypedefName, isArray, isBit, isCompound, isConst, isDouble, isEnum, isFloat, isFunction, isInt, isPointer, isPrimitive, isVoid, isVolatile, pointerDepth`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PointerType

          public PointerType(SizeThunk size,
                     Type targetType,
                     int cvAttributes)

  - ### Method Detail

    - #### hashCode

          public int hashCode()

      Description copied from class: `Type`
      Hashcode for Types.
      Overrides:
        `hashCode` in class `Type`

    - #### equals

          public boolean equals(Object arg)

      Description copied from class: `Type`
      Equality test for Types.
      Overrides:
        `equals` in class `Type`

    - #### setName

          public void setName(String name)

      Description copied from class: `Type`
      Set the name of this type; used for handling typedefs.
      Overrides:
        `setName` in class `Type`

    - #### getName

          public String getName(boolean includeCVAttrs)

      Description copied from class: `Type`
      Returns the name of this type, optionally including const/volatile attributes. The returned string is suitable for use as a type specifier.
      Overrides:
        `getName` in class `Type`

    - #### hasTypedefedName

          public boolean hasTypedefedName()

    - #### asPointer

          public PointerType asPointer()

      Description copied from class: `Type`
      Casts this to a PointerType or returns null if not a PointerType.
      Overrides:
        `asPointer` in class `Type`

    - #### getTargetType

          public Type getTargetType()

    - #### getBaseElementType

          public Type getBaseElementType()

      Description copied from class: `Type`
      Helper method to returns the bottom-most element type of this type.

      If this is a multidimensional array or pointer method returns the bottom-most element type, otherwise this.

      Overrides:
        `getBaseElementType` in class `Type`

    - #### isFunctionPointer

          public boolean isFunctionPointer()

      Description copied from class: `Type`
      Convenience routine indicating whether this Type is a pointer to a function.
      Overrides:
        `isFunctionPointer` in class `Type`

    - #### toString

          public String toString()

      Description copied from class: `Type`
      Returns a string representation of this type. This string is not necessarily suitable for use as a type specifier; for example, it will contain an expanded description of structs/unions.
      Overrides:
        `toString` in class `Type`

    - #### toString

          public String toString(String functionName,
                        String callingConvention)

      For use only when printing function pointers. Calling convention string (i.e., "__stdcall") is optional and is generally only needed on Windows.

    - #### visit

          public void visit(TypeVisitor arg)

      Description copied from class: `Type`
      Visit this type and all of the component types of this one; for example, the return type and argument types of a FunctionType.
      Overrides:
        `visit` in class `Type`